<?

function getQuery($name, $defaultValue = "")
{
    $v = $defaultValue;

    if ( isSet($_GET[$name]) ) {
        $v = $_GET[$name];
    }
    else if ( isSet($_POST[$name]) ) {
        $v = $_POST[$name];
    }
    $v = stripslashes($v);

    return $v;
}

function offerPapers()
{
    global $search;
    $foundSearchInCalendar = false;

    $dirPath = "papers/";
    $dir_handle = @opendir($dirPath) or die("Unable to open directory \"" . $dirPath . "\".");
    $s = "";
    $files = array();
    $fileI = 0;
    while ( $file = readDir($dir_handle) )
    {
        if ( !(strPos( $file, ".txt" ) === false) )
        {
            $files[$fileI++] = $file;
        }
    }
    closedir($dir_handle);
    sort($files);

    echo "<div class=\"edit\" id=\"paperLink\"> ";
    $countFiles = count($files);
    for ($i = 0; $i < $countFiles; $i++)
    {
        $file = $files[$i];
        $sClass = "";
        if ($search != "")
        {
            $fileText = getFileText("papers/" . $file);
            if ( !( strStr( strToLower($fileText), strToLower($search) ) === false) )
            {
                $foundSearchInCalendar = true;
                $sClass = " class=\"found\"";
            }
        }
        $pathText = str_replace(".txt", "", $file);
        $isNormalPaper = (strStr($file, "notes-") === false);
        $sImage = ($isNormalPaper) ? "paper.gif" : "calendar_day.gif";

        if ($isNormalPaper) echo "<strong>";
        echo "<a" . $sClass . " href=\"paper.php?path=" . $pathText . "\">";
        echo "<img src=\"style/" . $sImage . "\" alt=\"\" />";
        echo "&nbsp;" . $pathText . "</a>";
        if ($isNormalPaper) echo "</strong>";
        echo " &nbsp; ";
    }
    ?>
    <form action="paper.php" method="post" class="addPaper"><div>
        <input type="text" size="12" name="path" />
        <input type="hidden" name="paper" value="" />
        <input type="hidden" name="mode" value="save" />
        <input type="submit" value="Add paper" />
    </div></form>
    <?
    echo "</div>";

    return $foundSearchInCalendar;
}

function handleData($mode, $path)
{
    global $separator;
    global $rowId;
    $path = validatePath($path);

    if ( file_exists("tables/" . $path . ".dat") )
    {
        $rows = file("tables/" . $path . ".dat");
        $rows = stripReturns($rows);
        $table = getTableArray($rows);
    
        switch ($mode)
        {
            case "add":
                $table = addRow($table);
                saveTable($path, $table);
                $mode = "edit";
                break;
            case "delete":
                $table = deleteRow($table);
                saveTable($path, $table);
                $mode = "edit";
                break;
            case "updateRow":
                $table = updateRow($table, $rowId);
                saveTable($path, $table);
                $mode = "edit";
                break;
        }
    
        switch ($mode)
        {
            case "edit":
                handleEditData($path, $table);
                break;
            case "xml":
                echo getXml($table);
                break;
        }
    }
    else
    {
        header("Content-type: text/plain");
        echo "File not found.";
    }
}

function deleteTable($name)
{
    $name = validatePath($name);
    unlink("tables/" . $name . ".dat");
}

function offerAddTable()
{
    ?>
    <form action="index.php"><div>
        <table class="addTable">
        <caption>Add table</caption>
        <tr>
            <th>Title:</th>
            <td><input type="text" size="20" name="title" /></td>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <th>Columns:</th>
            <td>
            <? for ($i = 1; $i <= 9; $i++) { ?>
                <input type="text" size="8" name="newColumn<?=$i?>" />
            <? } ?>
            </td>
            <td>
                <input type="submit" value="Add" />
            </td>
        </tr>
        </table>
        <input type="hidden" name="mode" value="addTable" />
    </div></form>
    <?
}

function addTable()
{
    global $separator;
    global $title;
    global $newColumn1;
    global $newColumn2;
    global $newColumn3;
    global $newColumn4;
    global $newColumn5;
    global $newColumn6;
    global $newColumn7;
    global $newColumn8;
    global $newColumn9;

    if ($newColumn1 != "" ||
        $newColumn2 != "" ||
        $newColumn3 != "" ||
        $newColumn4 != "" ||
        $newColumn5 != "" ||
        $newColumn6 != "" ||
        $newColumn7 != "" ||
        $newColumn8 != "" ||
        $newColumn9 != "")
    {
        $s = "";
        $s .= "ID";
        if ( !isSet($title) ) { $title = ""; }
        $title = validatePath($title);
        if ($title != "")
        {
            if ($newColumn1 != "")
            { $s .= $separator . encodeData($newColumn1); }
            if ($newColumn2 != "")
            { $s .= $separator . encodeData($newColumn2); }
            if ($newColumn3 != "")
            { $s .= $separator . encodeData($newColumn3); }
            if ($newColumn4 != "")
            { $s .= $separator . encodeData($newColumn4); }
            if ($newColumn5 != "")
            { $s .= $separator . encodeData($newColumn5); }
            if ($newColumn6 != "")
            { $s .= $separator . encodeData($newColumn6); }
            if ($newColumn7 != "")
            { $s .= $separator . encodeData($newColumn7); }
            if ($newColumn8 != "")
            { $s .= $separator . encodeData($newColumn8); }
            if ($newColumn9 != "")
            { $s .= $separator . encodeData($newColumn9); }
        
            if ( !file_exists($title . ".dat") )
            {
                $writeOnly = "w";
                $filePointer = fOpen("tables/" . $title . ".dat", $writeOnly);
                fWrite($filePointer, $s);
            }
        }
    }
}

function offerData()
{
    global $path;
    global $search;
    global $askDeleteTable;

    $dirPath = "tables/";
    $dir_handle = @opendir($dirPath) or die("Unable to open directory \"" . $dirPath . "\".");
    $s = "";
    $files = array();
    $fileI = 0;
    while ( $file = readDir($dir_handle) )
    {
        if ( !(strPos( $file, ".dat" ) === false) )
        {
            $files[$fileI++] = $file;
        }
    }
    closedir($dir_handle);
    sort($files);

    $countFiles = count($files);
    for ($i = 0; $i < $countFiles; $i++)
    {
        $file = $files[$i];
        $text = str_replace(".dat", "", $file);
        $fileSize = intVal( fileSize("tables/" . $file) / 1024 );
        if ($fileSize == 0)
        {
            $fileSize = "below 1";
        }
        $sClass = "";
        $sSearch = "";
        if ($search != "")
        {
            $fileText = strToLower( getFileText("tables/" . $file) );
            if ( !strPos( $fileText, strToLower($search) ) === false)
            {
                $sClass = " class=\"found\"";
                $sSearch = "&amp;search=" . $search;
            }
        }
        $s .= "<tr>";
        $s .= "<td class=\"tableTitle\"><strong class=\"edit\"><a " . $sClass . " href=\"index.php?path=" . $text .
                $sSearch . "\"><img src=\"style/table.gif\" alt=\"\" />&nbsp;" .
                $text . "</a></strong></td>";
        $s .= "<td class=\"fileDate\"><img src=\"style/time.gif\" alt=\"\" /> " .
                date( "F d, Y - H:i", fileMTime("tables/" . $file) ) . "</td>";
        $s .= "<td class=\"number\">" . $fileSize . "KB</td>";

        if ($askDeleteTable == $text)
        {
            $s .= "<td colspan=\"2\">";
            $s .= "Delete table? [<a href=\"index.php?doDeleteTable=" . $text . "\">Yes</a>/ " .
                    "<a href=\"index.php\">No</a>]";
            $s .= "</td>";
        }
        else
        {
            $s .= "<td class=\"cellEdit\"><a href=\"index.php?path=" . $text . "\">Edit</a></td>";
            $s .= "<td class=\"cellDelete\"><a href=\"index.php?askDeleteTable=" . $text . "\">Delete</a></td>";
        }
        $s .= "</tr>";
    }

    writeSearch($path);
    if ($s == "")
    {
        echo "<p>(There are no tables so far.)</p>";
    }
    else
    {
        echo "<table class=\"chooseTable\">";
        echo "<caption>Choose table:</caption>";
        echo "<tr><th>Name</th><th>Last change</th><th class=\"number\">Size</th><th colspan=\"2\">&nbsp;</th></tr>";
        echo $s;
        echo "</table>";
    }
}

function validatePath($path)
{
    $path = str_replace("\\", "", $path);
    $path = str_replace("/", "", $path);
    $path = str_replace(".", "", $path);
    $path = str_replace(" ", "_", $path);
    $path = str_replace(">", "", $path);
    $path = str_replace("<", "", $path);
    $path = str_replace("!", "", $path);
    $path = str_replace("?", "", $path);
    $path = str_replace(":", "", $path);
    $path = str_replace(";", "", $path);
    $path = str_replace("#", "", $path);
    $path = str_replace("&", "", $path);
    $path = str_replace("\"", "", $path);
    return $path;
}

function deleteRow($table)
{
    global $deleteId;

    if ($deleteId != "")
    {
        $tableCountI = count($table);
        for ($i = 0; $i < $tableCountI; $i++)
        {
            if ($table[$i][0] == $deleteId)
            {
                for ($j = 0; $j < count($table[$i]); $j++)
                {
                    $table[$i][$j] = null;
                }
                break;
            }
        }        
    }
    return $table;
}

function saveTable($path, $table)
{
    global $separator;
    $tableCountI = count($table);
    $tableCountJ = count($table[0]);
    $s = "";
    for ($i = 0; $i < $tableCountI; $i++)
    {
        if ( !is_null($table[$i][0]) )
        {
            for ($j = 0; $j < $tableCountJ; $j++)
            {
                if ( is_null($table[$i][$j]) )
                {
                    $table[$i][$j] = "";
                }
                $s .= encodeData($table[$i][$j]);
                if ($j < $tableCountJ - 1)
                {
                    $s .= $separator;
                }
            }
            if ($i < $tableCountI - 1)
            {
                $s .= "\r\n";
            }
        }
    }

    $writeOnly = "w";
    $filePointer = fOpen("tables/" . $path . ".dat", $writeOnly);
    fWrite($filePointer, $s);
}

function addRow($table)
{
    global $newColumn1;
    global $newColumn2;
    global $newColumn3;
    global $newColumn4;
    global $newColumn5;
    global $newColumn6;
    global $newColumn7;
    global $newColumn8;
    global $newColumn9;
    global $newColumn10;

    if ($newColumn1 != "" ||
        $newColumn2 != "" ||
        $newColumn3 != "" ||
        $newColumn4 != "" ||
        $newColumn5 != "" ||
        $newColumn6 != "" ||
        $newColumn7 != "" ||
        $newColumn8 != "" ||
        $newColumn9 != "" ||
        $newColumn10 != "")
    {
        $newId = getId($table);
        $nextI = count($table);
        $table[$nextI][0] = $newId;
        $table = updateRow($table, $newId);
    }
    return $table;
}

function updateRow($table, $rowId)
{
    global $newColumn1;
    global $newColumn2;
    global $newColumn3;
    global $newColumn4;
    global $newColumn5;
    global $newColumn6;
    global $newColumn7;
    global $newColumn8;
    global $newColumn9;
    global $newColumn10;

    $thisI = -1;
    $tableCount = count($table);
    for ($i = 1; $i < $tableCount; $i++)
    {
        if ($table[$i][0] == $rowId)
        {
            $thisI = $i;
            break;
        }
    }

    if ($thisI != -1)
    {
        if (count($table[0]) >= 2)
        { $table[$thisI][1] = $newColumn1; }
        if (count($table[0]) >= 3)
        { $table[$thisI][2] = $newColumn2; }
        if (count($table[0]) >= 4)
        { $table[$thisI][3] = $newColumn3; }
        if (count($table[0]) >= 5)
        { $table[$thisI][4] = $newColumn4; }
        if (count($table[0]) >= 6)
        { $table[$thisI][5] = $newColumn5; }
        if (count($table[0]) >= 7)
        { $table[$thisI][6] = $newColumn6; }
        if (count($table[0]) >= 8)
        { $table[$thisI][7] = $newColumn7; }
        if (count($table[0]) >= 9)
        { $table[$thisI][8] = $newColumn8; }
        if (count($table[0]) >= 10)
        { $table[$thisI][9] = $newColumn9; }
        if (count($table[0]) >= 11)
        { $table[$thisI][10] = $newColumn10; }
    }
    return $table;
}

function encodeData($data)
{
    global $encodedSeparator;
    global $encodedBreak;
    global $separator;
    $data = str_replace("\r\n", $encodedBreak, $data);
    $data = str_replace("\r", $encodedBreak, $data);
    $data = str_replace("\n", $encodedBreak, $data);
    $data = str_replace($separator, $encodedSeparator, $data);
    return $data;
}

function decodeData($data)
{
    global $encodedSeparator;
    global $encodedBreak;
    global $separator;
    $data = str_replace($encodedBreak, "\r\n", $data);
    $data = str_replace($encodedBreak, "\r", $data);
    $data = str_replace($encodedBreak, "\n", $data);
    $data = str_replace($encodedSeparator, $separator, $data);
    return $data;
}

function getId($table)
{
    $newId = 0;
    $tableCount = count($table);
    for ($i = 0; $i < $tableCount; $i++)
    {
        if ($newId < $table[$i][0])
        {
            $newId = $table[$i][0];
        }
    }

    return ++$newId;
}

function writeHtmlHeader($title = "Untitled", $linkToHome = true)
{
    ?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "DTD/xhtml1-strict.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
    <head>
        <title>QuickDat <?=$title?></title>
        <link rel="stylesheet" href="style/screen.css" type="text/css" media="screen" />
    </head>
    <body>
    <h1><img src="style/icon.gif" alt="" /> 
    <? if ($linkToHome)
    {
        echo "<a href=\"index.php\">QuickDat</a>";
    }
    else
    {
        echo "QuickDat";
    }
    ?>
    </h1>
    <?
}

function writeHtmlFooter($info = "")
{
    ?>
    <p class="footer">QuickDat 1.12 is Freeware &copy; 2002
        by Philipp Lenssen. Visit the <a href="http://outer-court.com/tech/quickdat.html">QuickDat homepage</a>.
    <?=$info?>
    </p>
    </body>
    </html>
    <?
}

function writeSearch($path)
{
    global $search;
    echo "<form action=\"index.php\" method=\"post\"><div>\r";
    echo "<input class=\"searchText\" type=\"text\" " .
            "name=\"search\" value=\"" . $search . "\" size=\"10\" />\r";
    echo "<input type=\"hidden\" name=\"path\" value=\"" . $path . "\" />\r";
    echo "<input class=\"searchButton\" type=\"submit\" value=\"Search\" />\r";
    echo "</div></form>\r";
}

function array_qsort (&$array, $column = 0, $order = SORT_ASC, $first = 0, $last= -2)
{
    // $array  - the array to be sorted
    // $column - index (column) on which to sort
    //           can be a string if using an associative array
    // $order  - SORT_ASC (default) for ascending or SORT_DESC for descending
    // $first  - start index (row) for partial array sort
    // $last   - stop  index (row) for partial array sort
    if($last == -2)
        $last = count($array) - 1;

    if($last > $first)
    {
        $alpha = $first;
        $omega = $last;
        $guess = $array[$alpha][$column];
        while($omega >= $alpha)
        {
            if($order == SORT_ASC)
            {
                while($array[$alpha][$column] < $guess) $alpha++;
                while($array[$omega][$column] > $guess) $omega--;
            }
            else
            {
                while($array[$alpha][$column] > $guess) $alpha++;
                while($array[$omega][$column] < $guess) $omega--;
            }
            if($alpha > $omega)
                break;
            $temporary = $array[$alpha];
            $array[$alpha++] = $array[$omega];
            $array[$omega--] = $temporary;
        }
        array_qsort ($array, $column, $order, $first, $omega);
        array_qsort ($array, $column, $order, $alpha, $last);
     }
}


function handleEditData($path, $table)
{
    global $separator;
    global $search;
    global $editId;
    global $sortIndex;

    array_qsort ($table, $sortIndex, SORT_ASC, 1, -2);

    $lowerSearch = strToLower($search);
    writeHtmlHeader($path);
    writeSearch($path);

    echo "<form action=\"index.php\" method=\"post\"><div>\r";
    echo "<table>\r";
    echo "<caption>" . $path . "</caption>\r";

    $tableCount = count($table);
    $sAlternate = "";
    for ($i = 0; $i < $tableCount; $i++)
    {
        if ( !is_null($table[$i][0]) )
        {
            $doDisplay = false;
            if ($search == "" || $i == 0)
            {
                $doDisplay = true;
            }
            else
            {
                for ($j = 1; $j < count($table[$i]); $j++)
                {
                    $data = strToLower($table[$i][$j]);
                    $pos = strpos($data, $lowerSearch);
                    if ( !($pos === false) )
                    {
                        $doDisplay = true;
                        break;
                    }
                }
            }

            if ($doDisplay)
            {
                echo "<tr".  $sAlternate . ">\r";
                $sAlternate = ($sAlternate == "" && $i > 0) ? " class=\"alternate\"" : "";

                for ($j = 1; $j < count($table[$i]); $j++)
                {
                    if ($editId == $table[$i][0])
                    {
                        $data = decodeData($table[$i][$j]);
                        $data = getXmlToText($data);
                        $size = strLen($table[$i][$j]) + 1;
                        if ( !($size >= 2 ) )
                        {
                            $size = 8;
                        }
                        echo "<td><input name=\"newColumn" . $j . "\" " .
                                "type=\"text\" size=\"" . $size . "\" " .
                                " value=\"" . $data . "\" /></td>\r";
                    }
                    else
                    {
                        $data = decodeData($table[$i][$j]);
                        $data = getXmlToText($data);

                        $tag = "";
                        $sClass = ($sortIndex == $j) ? " class=\"sorted\"" : "";
                        if ($i == 0)
                        {
                            $tag = "th";
                            $sIndex = ($sortIndex != $j) ? "&amp;sortIndex=" . $j : "";
                            $data = "<a href=\"index.php?" .
                                    "mode=edit&amp;path=" . $path . $sIndex .
                                    "\">" . $data . "</a>";
                        }
                        else
                        {
                            $tag = "td";
                        }

                        echo "<" . $tag . $sClass . ">";

                        if ($i >= 1 && $data != "")
                        {
                            $name = strToLower($table[0][$j]);
                            if ($name == "homepage" || $name == "url" || $name == "webpage")
                            {
                                $data = "<a href=\"" . $data . "\">" . cutLength( cutStart($data, "http://" ), 18 ) . "</a>";
                            }
                            else if ($name == "email" || $name == "e-mail" || $name == "mail")
                            {
                                $data = "<a href=\"mailto:" . $data . "\">" . cutLength($data, 18) . "</a>";
                            }
                            else if ($search != "")
                            {
                                $data = str_replace($search, "<span class=\"found\">" .
                                        $search . "</span>", $data);
                            }
                        }
                        echo ($data == "") ? "&nbsp;" : $data;
                        echo "</" . $tag . ">\r";
                    }
                }
                if ($i == 0)
                {
                    echo "<td class=\"emptyDelete\" colspan=\"2\">&nbsp;</td>";
                }
                else
                {
                    if ($editId == $table[$i][0])
                    {
                        echo "<td colspan=\"2\">";
                        echo "<input type=\"hidden\" name=\"rowId\" value=\"" .
                                $editId . "\" />";
                        echo "<input type=\"hidden\" name=\"sortIndex\" value=\"" .
                                $sortIndex . "\" />";
                        echo "<input type=\"hidden\" name=\"mode\" value=\"updateRow\" />";
                        echo "<input type=\"submit\" value=\"Update\" />";
                        echo "</td>";
                    }
                    else
                    {
                        echo "<td class=\"cellEdit\">";
                        echo "<a href=\"index.php?mode=edit&amp;editId=" . $table[$i][0] .
                                "&amp;path=" . $path . "&amp;sortIndex=" . $sortIndex . "\">Edit</a>";
                        echo "</td><td class=\"cellDelete\"><a href=\"index.php?mode=delete&amp;deleteId=" . $table[$i][0] .
                                "&amp;path=" . $path . "&amp;sortIndex=" . $sortIndex . "\">Delete</a>";
                        echo "</td>";
                    }

                }
                echo "</tr>";
            }
        }
    }

    if ($editId == "")
    {
        $tableCount = count($table[0]);
        for ($j = 1; $j < $tableCount; $j++)
        {
            $size = 8;
            echo "<td><input name=\"newColumn" . $j . "\" " .
                "type=\"text\" size=\"" . $size . "\" /></td>\r";
        }
        echo "<td colspan=\"2\"><input type=\"submit\" value=\"Add\" />";
        echo "<input type=\"hidden\" name=\"mode\" value=\"add\" />\r";
        echo "</td>\r";
        echo "</tr>\r";
    }

    echo "</table>\r";
    echo "<p>" .
            "<strong><a href=\"index.php\"><img src=\"style/table.gif\" alt=\"\" /> Choose table</a></strong> | " .
            "<a href=\"tables/" . $path . ".dat\">This data as CSV</a> | " .
            "<a href=\"index.php?path=" . $path . "&amp;mode=xml\">This data as XML</a>" .
            "</p>\r";

    echo "<input type=\"hidden\" name=\"path\" value=\"" . $path . "\" />\r";
    echo "</div></form>\r";
    writeHtmlFooter();
}

function cutLength($s, $maxLength = 20, $ending = "...")
{
    if ( strLen($s) > $maxLength )
    {
        $s = subStr($s, 0, $maxLength - strLen($ending) ) . $ending;
    }
    return $s;
}

function cutStart($s, $sStart)
{
    if ( subStr($s, 0, strLen($sStart) ) == $sStart )
    {
        $s = subStr( $s, strLen($sStart) );
    }
    return $s;
}

function getXml($table)
{
    global $separator;
    header("Content-type: text/xml");
    $xml = "";
    $xml .="<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\r";
    $xml .="<items>\r";
    for ($i = 1; $i < count($table); $i++)
    {
        $xml .= "    <item id=\"" . $table[$i][0] . "\">\r";
        for ($j = 1; $j < count($table[$i]); $j++)
        {
            $tag = $table[0][$j];
            $tag = str_replace(" ", "-", $tag);
            $xml .= "        <" . $tag . ">";
            $data = decodeData($table[$i][$j]);
            $data = getXmlToText($data);
            $xml .= $data;
            $xml .= "</" . $tag . ">\r";
        }
        $xml .= "    </item>\r";
    }
    $xml .= "</items>\r";
    return $xml;
}

function getXmlToText($text)
{
    $text = str_replace("&", "&amp;", $text);
    $text = str_replace("<", "&lt;", $text);
    $text = str_replace(">", "&gt;", $text);
    $text = str_replace("\"", "&quot;", $text);
    return $text;
}

function getTableArray($rows)
{
    global $separator;
    $table = array();

    for ($i = 0; $i < count($rows); $i++)
    {
        $columns = split($separator, $rows[$i]);
        for ($j = 0; $j < count($columns); $j++)
        {
            $table[$i][$j] = $columns[$j];
        }
    }
    return $table;
}

function stripReturns($fileArray)
{
    $windowsStyle = "\r\n";
    $unixStyle1 = "\r";
    $unixStyle2 = "\n";

    for ( $i = 0; $i < count($fileArray); $i++ )
    {
        $fileArray[$i] = str_replace( $windowsStyle, "", $fileArray[$i] );
        $fileArray[$i] = str_replace( $unixStyle1, "", $fileArray[$i] );
        $fileArray[$i] = str_replace( $unixStyle2, "", $fileArray[$i] );
    }
    return $fileArray;
}

function getFileText($filePath)
{
    $fileText = "";

    $fileArray = file($filePath);
    for ($i = 0; $i < count($fileArray); $i++)
    {
        $fileText .= $fileArray[$i];
    }

    return $fileText;
}

function pad($n)
{
    if ( strLen($n) == "1" )
    {
        $n = "0" . $n;
    }
    return $n;
}

?>